<?php

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
/*

	Paloose Entry Point for Paloose Info Site
	=========================================
	
	All site requests come through this file. All it does is load the primary
	Paloose file and class. It requires that there is a rewrite rule set up in
	the local .htaccess file. The entry in this file should be similar to

		RewriteEngine On
		RewriteRule (.+)\.html paloose.php?url=$1.html [L,qsappend]

   Author:
   	Name  : Hugh Field-Richards.
   	Email : hsfr@hsfr.org.uk

-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- Copyright -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

	This software is published under the terms of the LGPL License
	a copy of which has been included with this distribution in the LICENSE file.
                  
*/

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Change the PALOOSE_DIRECTORY address here to indicate where you have put
// the main Paloose folder. It can be relative to your application site folder.
define( 'PALOOSE_DIRECTORY', '../paloose' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Where the main log4php logger configuration file is kept. You can use pseudo
// protocols here.
define( 'LOGGER_CONFIG', 'context://configs/Paloose.xml' );
define( 'LOG4PHP_DIR', '../log4php' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Where the paloose caches are held. Does not include the images cache for
// the directory. 
define( 'CACHE_DIR', '/tmp' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Normally should not have to change this. The directory is always the top
// level user directory.
define( 'ROOT_SITEMAP', 'sitemap.xmap' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// The error page to give back for User errors (errors in sitemap etc). They
// are not run time errors (missing page (404) ). If you override these to your
// area make sure that you use an absolute directory path - you can use the
// 'context' pseudo-protocol here.
define( 'USER_EXCEPTION_PAGE', 'resource://resources/errorHandling/userError.html' );
define( 'USER_EXCEPTION_TRANSFORM', 'resource://resources/transforms/errorPage2html.xsl' );
// Be careful of the path here - although it is relative it looks as an absolute one. It is in
// fact relative to the Apache root document directory. Must always have a leading path
// separator.
define( 'USER_EXCEPTION_STYLE', '/paloose/resources/styles/userError.css' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// The file that contains the gallery information in each gallery directory
define( 'GALLERY_INDEX', 'gallery.xml' );

// Define if PATH on server is not set to pick up correct ImageMagick binaries
//define( 'IMAGEMAGICK_BIN', '/usr/local/bin/' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// The error page to give back for internal programming errors. These should
// not need to be overridden.
define( 'INTERNAL_EXCEPTION_PAGE', 'resource://resources/errorHandling/internalError.html' );
define( 'INTERNAL_EXCEPTION_TRANSFORM', 'resource://resources/transforms/errorPage2html.xsl' );
// Be careful of the path here - although it is relative it looks as an absolute one. It is in
// fact relative to the Apache root document directory. Must always have a leading path
// separator.
define( 'INTERNAL_EXCEPTION_STYLE', '/paloose/resources/styles/internalError.css' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Change this with caution - should not be changed in 99.9% of cases
define( 'SITEMAP_NAMESPACE', 'http://apache.org/cocoon/sitemap/1.0' );
define( 'SOURCE_NAMESPACE', 'http://apache.org/cocoon/source/1.0' );
define( 'DIR_NAMESPACE', 'http://apache.org/cocoon/directory/2.0' );
define( 'SQL_QUERY_NAMESPACE', 'http://apache.org/cocoon/SQL/2.0' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Change this with caution - should only be changed for different translation
// mechanism. Requires understanding of Paloose internals :-)
define( 'I18N_NAMESPACE', 'http://apache.org/cocoon/i18n/2.1' );
define( 'PAGE_HIT_TRANSFORM', 'resource://resources/transforms/PageHit.xsl' );

// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* -->
// Do not change anything below this line!

define( 'PALOOSE_NAMESPACE', 'http://www.paloose.org/schemas/Paloose/1.0' );

require_once( PALOOSE_DIRECTORY . '/lib/Paloose.php' );

?>